import React from "react";
import "./App.css";
import { Viewer } from "@grapecity/activereports-react";
import {Core} from "@grapecity/activereports"

function App() {
  const viewerRef = React.useRef(null);
  var currentReport=null;
  React.useEffect(() => {
    if (!viewerRef.current) return;
    var printButton = {
      key: "$print",
      iconCssClass: "mdi mdi-printer",
      text: "",
      enabled: true,
      action: function (item) {
        console.log("Print!");
        if(currentReport.parameters.PageNumbers)
        {
          //Set Parameter value as all of the valid values so PageNumebers Parameter now equals [1,2,3,4,5,6,7,8]
          currentReport.parameters.PageNumbers.values=currentReport.parameters.PageNumbers.validValues.map(item => item.value);
        }
        currentReport.run().then((doc)=>{
          doc.print(); //Prints the modified report
        });       
      },
    };
    viewerRef.current.Viewer.toolbar.updateItem("$print",printButton);    
  }, []);
  const reportLoaded=(e)=>{
    currentReport=e.report;
  }
  return (
    <div id="viewer-host">
      <Viewer ref={viewerRef} report={{ Uri: 'PageNumberReport.rdlx-json' }} reportLoaded={reportLoaded}/>
    </div>
  );
}

export default App;